Public Class Form1

    Private Sub TboxEnter(ByVal sender As Object, ByVal e As System.EventArgs)

        DirectCast(sender, TextBox).BackColor = Color.PaleTurquoise
    End Sub

    Private Sub TboxNInsertError(ByVal sender As Object, _
                                 ByVal e As TextboxNum.EventArgs)

        'Eingabefehler behandeln
    End Sub

    Private Sub TboxKeyPress(ByVal sender As Object, _
                             ByVal e As System.Windows.Forms.KeyPressEventArgs)

        If e.KeyChar = Convert.ToChar(13) Then
            e.Handled = True
            SendKeys.Send("{Tab}")
        End If
    End Sub

    Private Sub TboxLeave(ByVal sender As Object, ByVal e As System.EventArgs)

        DirectCast(sender, TextBox).BackColor = SystemColors.Window
    End Sub


    Private Sub Form1_Load(ByVal sender As System.Object, _
                           ByVal e As System.EventArgs) Handles MyBase.Load

        TextBoxHandlesAdd(Me)
    End Sub

    Private Sub TextBoxHandlesAdd(ByVal Container As Control, _
            Optional ByVal SubContainerAlso As Boolean = True)

        For Each Ctl As Control In Container.Controls
            If TypeOf Ctl Is TextBox Then
                AddHandler Ctl.Enter, AddressOf TboxEnter
                AddHandler Ctl.KeyPress, AddressOf TboxKeyPress
                AddHandler Ctl.Leave, AddressOf TboxLeave

            ElseIf TypeOf Ctl Is TextboxNum Then
                Dim Tbox As TextboxNum = DirectCast(Ctl, TextboxNum)
                AddHandler Tbox.InsertError, AddressOf TboxNInsertError

            ElseIf (Ctl.Controls.Count > 0) AndAlso SubContainerAlso Then
                TextBoxHandlesAdd(Ctl, SubContainerAlso)
            End If
        Next
    End Sub


    Private Sub TextboxNum1_TextChanged(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles TextboxNum1.TextChanged

    End Sub
End Class
